//---plik UnitMain.cpp------------------------------
#include <vcl.h>
#pragma hdrstop
#include "UnitKlasa.h"
#include "UnitMain.h"
//---------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
const AnsiString asUnitKlasaH("UnitKlasa.h");/*nazwa pliku*/
const AnsiString asUnitKlasaCPP("UnitKlasa.cpp");/*nazwa pliku*/
const AnsiString asUnitMainCPP("UnitMain.cpp");/*nazwa pliku*/

TFormMain *FormMain;
//---------------------------------------------------
__fastcall TFormMain::TFormMain(TComponent* Owner)
  : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::FormCreate(TObject *Sender)
{
  //=== Wywietlenie deklaracji klasy ========================
  /*---nazwa katalogu, w ktrym znajduje si aplikacja:*/
  AnsiString asKat=ExtractFilePath(ParamStr(0));
  AnsiString as1=asKat+asUnitKlasaH;/*nazwa pliku ze ciek*/
  Memo1->Lines->LoadFromFile(as1);/*adowanie pliku z deklaracj klasy*/
  //=== Wywietlenie implementacji metod klasy ===============
  AnsiString as2=asKat+asUnitKlasaCPP;/*nazwa pliku ze ciek*/
  Memo2->Lines->LoadFromFile(as2);/*adowanie pliku z implementacjami metod klasy*/
  //=== Wywietlenie pliku z komponentami klasy ===============
  AnsiString as3=asKat+asUnitMainCPP;/*nazwa pliku ze ciek*/
  Memo3->Lines->LoadFromFile(as3);/*adowanie pliku z obiektami klasy*/
  //==========================================================
  Image1->Canvas->Brush->Color=TColor(0x02C0C0C0);
  Image1->Canvas->Rectangle(Image1->ClientRect);
  m_pWatek=NULL;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::BitBtnStartClick(TObject *Sender)
{
  //=== Wtek ===
  if (m_pWatek==NULL) m_pWatek = new KlasaW(true); // tylko kreacja wtku
  m_pWatek->Priority = tpLower; // priorytet mniej ni normalny
  m_pWatek->FreeOnTerminate = false; //bez "automatycznego" niszczenia obiektu
  m_pWatek->Resume(); // start wtku
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::BitBtnZatrzymanieClick(TObject *Sender)
{
  if (m_pWatek->Suspended==false) m_pWatek->Suspend();
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::BitBtnKontynuowanieClick(TObject *Sender)
{
  m_pWatek->Resume();
}
//---------------------------------------------------------------------------

void __fastcall TFormMain::BitBtnStopClick(TObject *Sender)
{
  m_pWatek->Terminate();
  if (m_pWatek) delete m_pWatek;
  m_pWatek=NULL;
}
//---------------------------------------------------------------------------

