//---plik UnitMain.cpp------------------------------
#include <vcl.h>
#pragma hdrstop
#include "UnitFunc.h"
#include "UnitWtyczkaMain.h"
//---------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
const AnsiString asUnitKlasaH("UnitFunc.h");/*nazwa pliku*/
const AnsiString asUnitKlasaCPP("UnitWtyczkaMain.cpp");/*nazwa pliku*/
const AnsiString asUnitMainCPP("ProjectWtyczka.cpp");/*nazwa pliku*/

TFormMain *FormMain;
//---------------------------------------------------
__fastcall TFormMain::TFormMain(TComponent* Owner)
  : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::FormCreate(TObject *Sender)
{
  //=== Wywietlenie deklaracji klasy ========================
  /*---nazwa katalogu, w ktrym znajduje si aplikacja:*/
  AnsiString asKat=ExtractFilePath(ParamStr(0));
  AnsiString as1=asKat+asUnitKlasaH;/*nazwa pliku ze ciek*/
  Memo1->Lines->LoadFromFile(as1);/*adowanie pliku z deklaracj klasy*/
  //=== Wywietlenie implementacji metod klasy ===============
  AnsiString as2=asKat+asUnitKlasaCPP;/*nazwa pliku ze ciek*/
  Memo2->Lines->LoadFromFile(as2);/*adowanie pliku z implementacjami metod klasy*/
  //=== Wywietlenie pliku z komponentami klasy ===============
  AnsiString as3=asKat+asUnitMainCPP;/*nazwa pliku ze ciek*/
  Memo3->Lines->LoadFromFile(as3);/*adowanie pliku z obiektami klasy*/
  //==========================================================
}
//---------------------------------------------------------------------------
typedef void* (* Typ_tworz)();
extern "C" __declspec(dllexport) void* TworzKwadrat();
typedef void* (* Typ_tworz2)(int arg);
extern "C" __declspec(dllexport) void* TworzKwadrat2(int arg);
HINSTANCE dllInstance; //deskryptor biblioteki

void __fastcall TFormMain::BitBtnStartClick(TObject *Sender)
{
  //=== Wtyczka =================
Typ_tworz pfunc; //wskanik na funkcj
Figury* pabstr=NULL; //wskanik na klas abstrakcyjn
dllInstance=::LoadLibrary("ProjectWtyczkaDLL.dll");
if (dllInstance)
{ pfunc=(Typ_tworz)GetProcAddress(dllInstance,"_TworzKwadrat");
  if (pfunc) pabstr=(Figury* )pfunc();
  if (pabstr)
  { char* pname=pabstr->PodajNazwe(); /* wywoanie funkcji DLL, ale przez obiekt */
    int pole=pabstr->PodajPole(); /* wywoanie funkcji DLL, ale przez obiekt */
    AnsiString as1=AnsiString(pname);
    AnsiString as2=AnsiString("Pole=")+AnsiString(pole);
    Image1->Canvas->TextOutA(10,10,as1);
    Image1->Canvas->TextOutA(10,30,as2);
    delete pabstr;
  }
  ::FreeLibrary(dllInstance);
}
//=========================
Typ_tworz2 pfunc2; //wskanik na funkcj
pabstr=NULL; //wskanik na klas abstrakcyjn
dllInstance=::LoadLibrary("ProjectWtyczkaDLL.dll");
if (dllInstance)
{ pfunc2=(Typ_tworz2)GetProcAddress(dllInstance,"_TworzKwadrat2");
  if (pfunc2) pabstr=(Figury* )pfunc2(50);
  if (pabstr)
  { char* pname=pabstr->PodajNazwe(); /* wywoanie funkcji DLL, ale przez obiekt */
    int pole=pabstr->PodajPole(); /* wywoanie funkcji DLL, ale przez obiekt */
    AnsiString as1=AnsiString(pname);
    AnsiString as2=AnsiString("Pole=")+AnsiString(pole);
    Image1->Canvas->TextOutA(10,50,as1);
    Image1->Canvas->TextOutA(10,70,as2);
    delete pabstr;
  }
  ::FreeLibrary(dllInstance);
}

}
//---------------------------------------------------------------------------


