//---plik UnitMain.cpp------------------------------
#include <vcl.h>
#include <comobj.hpp>
#pragma hdrstop
#include "UnitMain.h"
//---------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
const AnsiString asUnitKlasaH("UnitKlasa.h");/*nazwa pliku*/
const AnsiString asUnitKlasaCPP("UnitKlasa.cpp");/*nazwa pliku*/
const AnsiString asUnitMainCPP("UnitMain.cpp");/*nazwa pliku*/
TFormMain *FormMain;
//---------------------------------------------------
__fastcall TFormMain::TFormMain(TComponent* Owner)
  : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::FormCreate(TObject *Sender)
{
  //=== Wywietlenie deklaracji klasy ========================
  /*---nazwa katalogu, w ktrym znajduje si aplikacja:*/
  AnsiString asKat=ExtractFilePath(ParamStr(0));
  //=== Wywietlenie pliku z komponentami klasy ===============
  AnsiString as1=asKat+asUnitMainCPP;/*nazwa pliku ze ciek*/
  Memo1->Lines->LoadFromFile(as1);/*adowanie pliku z obiektami klasy*/
  //==========================================================
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::ButtonWord1Click(TObject *Sender)
{
  //=== Przykad. Aktualny (tj. otwarty) dokument MS Word ====
  RichEdit1->Clear();
  Variant app=Variant::GetActiveObject("Word.Application");
  Variant docs=app.OlePropertyGet("Documents");
  Variant countDocs=docs.OlePropertyGet("Count");
  AnsiString as1=AnsiString("Liczba otwartych dokumentw Word = ")+AnsiString(countDocs);
  RichEdit1->Lines->Add(as1);
  Variant fns=app.OlePropertyGet("FontNames");
  Variant countFonts=fns.OlePropertyGet("Count");
  AnsiString as2=AnsiString("Liczba czcionek dokumentu Word = ")+AnsiString(countFonts);
  RichEdit1->Lines->Add(as2);
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::ButtonWord2Click(TObject *Sender)
{
  //=== Przykad.
  Variant app=Variant::GetActiveObject("Word.Application");
  Variant select=app.OlePropertyGet("Selection");
  RichEdit1->Clear();
  RichEdit1->Text=select.OlePropertyGet("Text");

}
//---------------------------------------------------------------------------
void __fastcall TFormMain::ButtonWord3Click(TObject *Sender)
{
  Variant app=Variant::GetActiveObject("Word.Application");
  Variant doc=app.OlePropertyGet("ActiveDocument");
  doc.OleProcedure("Select");
/** lub  Procedure selectDoc("Select");  doc.Exec(selectDoc); **/
  Variant sel=app.OlePropertyGet("Selection");
  RichEdit1->Clear();
  RichEdit1->Text=sel.OlePropertyGet("Text");
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::ButtonWord4Click(TObject *Sender)
{
  long	cols=4;
  long	rows=(ListBox1->Items->Count+cols-1)/cols;
  Variant app=Variant::GetActiveObject("Word.Application");
  Variant doc=app.OlePropertyGet("ActiveDocument");
/** lub nowy dokument:  Variant docs=app.OlePropertyGet("Documents");
  Variant doc=docs.OleFunction("Add"); **/
  //-- Pobierz kolekcj "tables" z zakresu
  Variant range=doc.OleFunction("Range",0,0);
  Variant tables=range.OlePropertyGet("Tables");
  Variant table=tables.OleFunction ("Add",range,(Variant)(rows+1),(Variant)(cols));
  Variant start_cell=table.OleFunction ("Cell",(Variant)1,(Variant)1);//nagwek
  Variant end_cell= table.OleFunction ("Cell",(Variant)1,(Variant)cols);
  start_cell.OleProcedure("Merge",end_cell);
  Variant cell_range=start_cell.OlePropertyGet("Range");
  Procedure InsertAfter("InsertAfter");
  cell_range.Exec(InsertAfter << "Sowa");//Tytu tabelki
  int col=1; int row=2;
  //-- Wstawianie sw z listy:
  for (int jword=0;jword<ListBox1->Items->Count;jword++)
  {
    start_cell=table.OleFunction ("Cell",(Variant)row,(Variant)col);
    cell_range=start_cell.OlePropertyGet("Range");
    InsertAfter.ClearArgs();
    cell_range.Exec(InsertAfter << ListBox1->Items->Strings[jword]);
    col++; if (col > cols) { row++; col=1; }
  }

}
//---------------------------------------------------------------------------

