//---------------------------------------------------------------------------

#ifndef Unit1H
#define Unit1H
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Buttons.hpp>
#include <ComCtrls.hpp>
#include "SerwerAsyn_TLB.h"
//---------------------------------------------------------------------------
class TForm1 : public TForm
{
__published:	// IDE-managed Components
  TPageControl *PageControl1;
  TTabSheet *TabSheet1;
  TLabel *Label7;
  TMemo *Memo1;
  TTabSheet *TabSheet2;
  TBitBtn *BitBtn1;
  TRichEdit *RichEdit1;
  void __fastcall FormCreate(TObject *Sender);
  void __fastcall BitBtn1Click(TObject *Sender);
  void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
private:	// User declarations
  TCOMIProcesorAsyn FProcesorAsyn;
protected:
public:		// User declarations
  __fastcall TForm1(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------
#include <atlbase.h>
#include <utilcls.h>
// Klasa obsugujca interfejs IProcesorAsynEvents
class TProcesorAsynSink : public TEventDispatcher<TProcesorAsynSink,
  &DIID_IProcesorAsynEvents>
{
protected:
  // Dystrybutor zdarze
  HRESULT InvokeEvent(DISPID id, TVariant* params)
  { if ((id == 1) && (OnParamProcesorGotowe != NULL))
    { Variant v=params[0];
      Variant v2=VarAsType(v,varString);
      AnsiString aa=v2.operator AnsiString();
      LPSTR lp=aa.c_str();
      OnParamProcesorGotowe(lp);
    }
    return S_OK;
  }
  // Referencja do rda zdarzenia
  CComPtr<IUnknown> m_pSender;
public:
  TProcesorAsynSink(): m_pSender(NULL) { }
  virtual ~TProcesorAsynSink() { Disconnect(); }
  // Poczenie z serwerem
  void Connect(IUnknown* pSender)
  { if (pSender != m_pSender) m_pSender = pSender;
    if (NULL != m_pSender) ConnectEvents(m_pSender);
  }
  // Odczenie od serwera
  void Disconnect()
  { if (NULL != m_pSender)
    { DisconnectEvents(m_pSender);
      m_pSender = NULL;
    }
  }
};

#endif
