// PROCESORASYNIMPL : Implementation of TProcesorAsynImpl (CoClass: ProcesorAsyn, Interface: IProcesorAsyn)

#include <vcl.h>
#pragma hdrstop

#include "PROCESORASYNIMPL.H"

/////////////////////////////////////////////////////////////////////////////
// TProcesorAsynImpl

STDMETHODIMP TProcesorAsynImpl::PodajParamProcesorAsyn()
{
 static char produc[12][16]={
  "GenuineIntel" /* Intel */,
  "AuthenticAMD" /* AMD */,
  "CyrixInstead" /* Cyrix */,
  "CentaurHauls" /* Centaur */,
  "SiS SiS SiS " /* SiS */,
  "NexGenDriven" /* NexGen */,
  "GenuineTMx86" /* Transmeta */,
  "TransmetaCPU" /* Transmeta */,
  "RiseRiseRise" /* Rise */,
  "UMC UMC UMC " /* UMC */,
  "Geode by NSC" /* National Semiconductor */,
  "AMDisbetter!" /* AMD K5 processor */
};
  __int32 ibx, idx, icx;
  /* wstawka asemblerowa; producent procesora: */
  asm mov EAX, 0
  asm cpuid
  asm mov ibx, EBX
  asm mov idx, EDX
  asm mov icx, ECX
  memmove(&dane[0],(char*)&ibx,4);
  memmove(&dane[4],(char*)&idx,4);
  memmove(&dane[8],(char*)&icx,4);
  dane[12]='\n';
  dane[13]='\n';
  for (int j=0;j<12;j++)
  {
    int k=14+13*j;
    memmove(&dane[k],produc[j],12);
    dane[k+12]='\n';
  }
  dane[170]='\0';
  //-----------------------------
  Fire_OnParamProcesorGotowe(dane);
  //-----------------------------
  return S_OK;
}

