//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "UnitData.h"
#include "UnitMain.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
///const AnsiString asUnitKlasaH("UnitKlasa.h");/*nazwa pliku*/
///const AnsiString asUnitKlasaCPP("UnitKlasa.cpp");/*nazwa pliku*/
const AnsiString asUnitMainCPP("UnitMain.cpp");/*nazwa pliku*/
TMainForm *MainForm;
//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
  : TForm(Owner)
{
  ShortDateFormat = ("yyyy-mm-dd");
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::FormCreate(TObject *Sender)
{
  //=== Wywietlenie deklaracji klasy ========================
  /*---nazwa katalogu, w ktrym znajduje si aplikacja:*/
  AnsiString asKat=ExtractFilePath(ParamStr(0));
  //=== Wywietlenie pliku z komponentami klasy ===============
  AnsiString as1=asKat+asUnitMainCPP;/*nazwa pliku ze ciek*/
  Memo1->Lines->LoadFromFile(as1);/*adowanie pliku z obiektami klasy*/
  //==========================================================
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ButtonZnakZodiakuClick(TObject *Sender)
{
  if (ZodiakDataModule->IBDatabaseZodiak->Connected==false)
  {
    WideString ws1= ExtractFilePath(Application->ExeName);
    WideString ws2=ws1+WideString("\\Zodiak.gdb");
    ZodiakDataModule->IBDatabaseZodiak->DatabaseName = ws2;
    ZodiakDataModule->IBDatabaseZodiak->Connected=true;
    ZodiakDataModule->IBTableZodiak->TableName="Zodiak";
  }
  if (ZodiakDataModule->IBTableZodiak->Active==false)
    ZodiakDataModule->IBTableZodiak->Open(); /* czenie z tabel */
  ZodiakDataModule->IBTableZodiak->FetchAll();
  //----------------
  PokazZnakInform(ZodiakDataModule->IBTableZodiak,MemoInfo->Lines);
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::ButtonClearClick(TObject *Sender)
{
  MemoInfo->Lines->Clear();
  if (ZodiakDataModule->IBTableZodiak->Active)
    ZodiakDataModule->IBTableZodiak->Close(); /* odczenie od tabeli */
  ZodiakDataModule->IBDatabaseZodiak->Connected=false;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormCloseQuery(TObject *Sender, bool &CanClose)
{
  if (ZodiakDataModule->IBTableZodiak->Active)
    ZodiakDataModule->IBTableZodiak->Close(); /* odczenie od tabeli */
  ZodiakDataModule->IBDatabaseZodiak->Connected=false;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ButtonZamknijClick(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void TMainForm::PokazZnakInform(TDataSet* pds,TStrings* pss)
{
  int nn=pds->RecordCount;
  if (nn==0) return;
  //-------------------------------
  TDateTime TheDate(Kalendarz->Date);
  unsigned short year = 0;
  unsigned short month = 0;
  unsigned short day = 0;
  TheDate.DecodeDate(&year, &month, &day);
  //-------------------------------
  pds->First(); /* zapis pierwsza */
  for (int j=0;j<nn;j++)
  {
    short shStartMonth=pds->FieldByName("StartMonth")->AsInteger;
    short shStartDay=pds->FieldByName("StartDay")->AsInteger;
    short shEndMonth=pds->FieldByName("EndMonth")->AsInteger;
    short shEndDay=pds->FieldByName("EndDay")->AsInteger;
    if (month==shStartMonth && day>=shStartDay ||
        month==shEndMonth && day<=shEndDay)
    {/* s sprawdzane dzie i miesic */
      pss->Add(("Informacje o znaku zodiaku:"));
      AnsiString as1=pds->FieldByName("Name")->AsString;
      pss->Add(("  Znak = ") + as1);
      AnsiString as2=pds->FieldByName("Element")->AsString;
      pss->Add(("  ywio = ") + as2);
      AnsiString as3=pds->FieldByName("Planet")->AsString;
      pss->Add(("  Planeta = ") + as3);
      AnsiString as4=pds->FieldByName("Description")->AsString;
      pss->Add(("  Szczegy = ") + as4);
      AnsiString as5=pds->FieldByName("Advice")->AsString;
      pss->Add(("  Rady = ") + as5);
      pss->Add((""));
      pss->Add((""));
      break;
    }
    pds->Next(); /* zapis nastepna */
  }//j
}
//---------------------------------------------------------------------------

