//---plik UnitMain.cpp------------------------------
#include <vcl.h>
#include <typeinfo.h>
#pragma hdrstop
#include "UnitKlasa.h"
#include "UnitMain.h"
//---------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
const AnsiString asUnitKlasaH("UnitKlasa.h");/*nazwa pliku*/
const AnsiString asUnitKlasaCPP("UnitKlasa.cpp");/*nazwa pliku*/
const AnsiString asUnitMainCPP("UnitMain.cpp");/*nazwa pliku*/

TFormMain *FormMain;
//---------------------------------------------------
__fastcall TFormMain::TFormMain(TComponent* Owner)
  : TForm(Owner)
{
  pliczn=NULL;
}
//---------------------------------------------------
void __fastcall TFormMain::BitBtnStartClick(TObject *Sender)
{
  //=== Wywietlenie deklaracji klasy ========================
  /*---nazwa katalogu, w ktrym znajduje si aplikacja:*/
  AnsiString asKat=ExtractFilePath(ParamStr(0));
  AnsiString as1=asKat+asUnitKlasaH;/*nazwa pliku ze ciek*/
  Memo1->Lines->LoadFromFile(as1);/*adowanie pliku z deklaracj klasy*/
  //=== Wywietlenie implementacji metod klasy ===============
  AnsiString as2=asKat+asUnitKlasaCPP;/*nazwa pliku ze ciek*/
  Memo2->Lines->LoadFromFile(as2);/*adowanie pliku z implementacjami metod klasy*/
  //=== Wywietlenie pliku z obiektami klasy ===============
  AnsiString as3=asKat+asUnitMainCPP;/*nazwa pliku ze ciek*/
  Memo3->Lines->LoadFromFile(as3);/*adowanie pliku z obiektami klasy*/
  //=== Definicja obiektw klasy =============================
  if (pliczn==NULL) pliczn=new Licznik;/*obiekt umieszczony na stercie*/
  Licznik liczn; /*obiekt umieszczony na stosie systemowym*/
  //--------------------
  int rozmiar=sizeof(*pliczn);/*rozmiar obszaru pamici*/
  StaticText3->Caption=AnsiString(rozmiar);/*wywietlenie rozmiaru*/
  //--------------------
  int stan1=pliczn->PodajStan();
  StaticText1->Caption=AnsiString(stan1);/*wywietlenie*/
  int stan2=liczn.PodajStan();
  StaticText2->Caption=AnsiString(stan2);/*wywietlenie*/

  //=== Informacja o klasie =============================
  TObject* pob=(TObject* )Components[0];
  TMetaClass* pmeta=pob->ClassType();
  if (pmeta!=NULL)
    StaticText4->Caption=AnsiString(pmeta->ClassName());

  //=== Mechanizm RTTI (Runtime type identification) ====
  if (typeid(*pliczn)==typeid(Licznik))
    StaticText5->Caption = typeid(pliczn).name();
}
//---------------------------------------------------
void __fastcall TFormMain::BitBtnPlusClick(TObject *Sender)
{
  if (pliczn==NULL) return;
  pliczn->Plus();
  int stan1=pliczn->PodajStan();
  StaticText1->Caption=AnsiString(stan1);/*wywietlenie*/
  Licznik liczn; /*obiekt umieszczony na stosie systemowym*/
  liczn.UstawStan(stan1);
  int stan2=liczn.PodajStan();
  StaticText2->Caption=AnsiString(stan2);/*wywietlenie*/

}
//---------------------------------------------------------------------------

void __fastcall TFormMain::BitBtnPlus16Click(TObject *Sender)
{
  if (pliczn==NULL) return;
  pliczn->Dodaj(16);
  int stan1=pliczn->PodajStan();
  StaticText1->Caption=AnsiString(stan1);/*wywietlenie*/
  Licznik liczn; /*obiekt umieszczony na stosie systemowym*/
  liczn.UstawStan(stan1);
  int stan2=liczn.PodajStan();
  StaticText2->Caption=AnsiString(stan2);/*wywietlenie*/

}
//---------------------------------------------------------------------------

void __fastcall TFormMain::FormCloseQuery(TObject *Sender, bool &CanClose)
{
  if (pliczn) { delete pliczn; pliczn=NULL; }

}

void __fastcall TFormMain::FormCreate(TObject *Sender)
{
  BitBtnStartClick(this);
}
//---------------------------------------------------------------------------

