//---plik UnitKlasa.h---------------------------
#ifndef UnitKlasaH
#define UnitKlasaH
#include <vcl.h>
//----------------------------------------------
class cTest1
{
  int dana;
public:
  cTest1(int arg) { dana=arg;}
};
class cTest2
{
  int dana;
public:
  explicit cTest2(int arg) { dana=arg;}
};
class Licznik: public TPersistent //pocztek deklaracji klasy
{
  static const int krok=16; /*pole stale oraz inicjalizacja pola*/
  int liczba; //deklaracja pola klasy
public:
  static int maxLiczba; //pole statyczne
  static int liczbaObjekt; //pole statyczne
  Licznik(); //deklaracja konstruktora klasy
  Licznik(const Licznik& obiekt); //konstruktor kopicy
  Licznik(const int stan); //konstruktor z argumentem
  __fastcall ~Licznik(); //destruktor klasy
  inline int Plus(); //deklaracja wstawianej metody klasy
  int PlusKrok() //deklaracja metody wstawianej
  { //implementacja metody wstawianej
    liczba+=krok;
    if (liczba>=maxLiczba) liczba-=maxLiczba;
    return liczba;
  }
  int Dodaj(int liczba); //deklaracja metody klasy
  int PodajStan(); //deklaracja metody klasy
  void UstawStan(int liczba); //deklaracja metody klasy
  /* waciwo klasy: */
  __property int stan = {read = PodajStan, write = UstawStan, default = 5};
};

#endif
