//---plik UnitKlasa.cpp------------------------------------------------------
#include <vcl.h>
#include <stdio.h>
#pragma hdrstop
#include "UnitKlasa.h"
//---------------------------------------------------------------------------
cA::cA(int pocz): liczba(pocz)
{
}
int cA::Plus1()
{
  ++liczba;
  return liczba;
}
int cA::PodajLiczba()
{
  return liczba;
}
cB::cB(int pocz) : cA(pocz){}
cC::cC(int pocz): cA(pocz){}
//=== Stos na bazie tablicy liczb cakowitych ===
StosT::StosT(): index(0) { }
bool StosT::CzyStosPusty()
{
  return(index==0);
}
void StosT::push(int elem)
{
  array[index]=elem;
  ++index;
}
int StosT::pop()
{
  --index;
  return(array[index]);
}
void StosT::Pokaz(TListBox* plb)
{
  plb->Clear();
  for (int k=0;k<index;k++)
  {
    int elem=array[k];
    plb->Items->Add(AnsiString(elem));
  }
}

//=== Stos na bazie struktury listowej =====
StosL::StosL(): pList(NULL) { }
StosL::~StosL() //destruktor
{
  ElListy *pp=pList;
  while (pp!=NULL)
  {
    ElListy *pTemp=pp;
    pp=pp->pNast; // usuwanie "z przodu"
    delete [] pTemp; //zwolnienie pamici
  }
}
bool StosL::CzyStosPusty()
{
  return(pList==NULL);
}
void StosL::push(int elem)
{
  ElListy *pTemp=pList;
  pList=new ElListy;
  pList->elem=elem;
  pList->pNast=pTemp; // dodawanie do listy "z przodu"
}
int StosL::pop()
{
  if (pList==NULL) return 0;
  int value=pList->elem;
  ElListy *pTemp=pList;
  pList=pList->pNast; // usuwanie listy "z przodu"
  delete pTemp; //zwolnienie pamici
  return(value);
}
void StosL::Pokaz(TListBox* plb)
{
  plb->Clear();
  ElListy *pp=pList;
  while (pp!=NULL)
  {
    plb->Items->Add(AnsiString(pp->elem));
    pp=pp->pNast; // usuwanie "z przodu"
  }
}
//=== Przecienie (ang. overloading) metody ======
Licznik::Licznik(): liczba(0) //konstruktor klasy
{
}
void Licznik::Set(int value) //metoda przeciona
{ if (value>=0 && value<100) liczba=value;
}
void Licznik::Set(char *pText) //metoda przeciajca
{ int nn;
  sscanf(pText,"%d",&nn);
  Set(nn);
}
int Licznik::Podaj()
{ return liczba;
}

#pragma package(smart_init)
