//---plik UnitMain.cpp------------------------------
#include <vcl.h>
#include <typeinfo.h>
#pragma hdrstop
#include "UnitKlasa.h"
#include "UnitMain.h"
//---------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
const AnsiString asUnitKlasaH("UnitKlasa.h");/*nazwa pliku*/
const AnsiString asUnitKlasaCPP("UnitKlasa.cpp");/*nazwa pliku*/
const AnsiString asUnitMainCPP("UnitMain.cpp");/*nazwa pliku*/

TFormMain *FormMain;
//---------------------------------------------------
__fastcall TFormMain::TFormMain(TComponent* Owner)
  : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::FormCreate(TObject *Sender)
{
  //=== Wywietlenie deklaracji klasy ========================
  /*---nazwa katalogu, w ktrym znajduje si aplikacja:*/
  AnsiString asKat=ExtractFilePath(ParamStr(0));
  AnsiString as1=asKat+asUnitKlasaH;/*nazwa pliku ze ciek*/
  Memo1->Lines->LoadFromFile(as1);/*adowanie pliku z deklaracj klasy*/
  //=== Wywietlenie implementacji metod klasy ===============
  AnsiString as2=asKat+asUnitKlasaCPP;/*nazwa pliku ze ciek*/
  Memo2->Lines->LoadFromFile(as2);/*adowanie pliku z implementacjami metod klasy*/
  //=== Wywietlenie pliku z komponentami klasy ===============
  AnsiString as3=asKat+asUnitMainCPP;/*nazwa pliku ze ciek*/
  Memo3->Lines->LoadFromFile(as3);/*adowanie pliku z obiektami klasy*/
  //==========================================================
}
//---------------------------------------------------------------------------

void __fastcall TFormMain::BitBtnStartClick(TObject *Sender)
{
  //=== Przykad. Deklaracja i implementacja w jzyku C++ interfejsu ITest =====
  /* korzystanie z interfejsu */
  ITest* pit=new ImplITest; /* wskanik na interfejs ITest rwny adresowi obiektu klasy ImplITest implementujcej interfejs */
  char* pch=pit->GetBuff();/* wywoanie metody interfejsu */
  MemoBufor->Lines->Strings[0]=AnsiString(pch);
  if (pit) delete pit;
  //=== Przykad. Dziedziczenie interfejsw w jzyku C++ ====
  /* korzystanie z interfejsw: */
  ImplIOkno ob;
  ob.UstawTekst(15,15,"test",0x000000FF);
  ob.UstawProstokat(10,10,40,30,0x00C0C0C0);
  ob.Rysowanie(PaintBox1);
  ImplIOkno* pok=new ImplIOkno(10,40,50,30,15,45,"test2",
    0x00C0C0C0,0x000000FF);
  pok->Rysowanie(PaintBox1);
  IOkno* pir=pok; /* wskanik na interfejs */
  pir->UstawTekst(15,75,"test3",0x000000FF);
  pir->UstawProstokat(10,70,50,30,0x00C0C0C0);
  pok->Rysowanie(PaintBox1);
  if (pok) delete pok;

}
//---------------------------------------------------------------------------







