//---plik UnitMain.cpp------------------------------
#include <vcl.h>
#include <stdio.h>
#include <exceptio.h>
using namespace std;
#pragma hdrstop
#include "UnitKlasa.h"
#include "UnitMain.h"
//---------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
const AnsiString asUnitKlasaH("UnitKlasa.h");/*nazwa pliku*/
const AnsiString asUnitKlasaCPP("UnitKlasa.cpp");/*nazwa pliku*/
const AnsiString asUnitMainCPP("UnitMain.cpp");/*nazwa pliku*/

TFormMain *FormMain;
//---------------------------------------------------
__fastcall TFormMain::TFormMain(TComponent* Owner)
  : TForm(Owner)
{
  stanStart=0;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::FormCreate(TObject *Sender)
{
  //=== Wywietlenie deklaracji klasy ========================
  /*---nazwa katalogu, w ktrym znajduje si aplikacja:*/
  AnsiString asKat=ExtractFilePath(ParamStr(0));
  AnsiString as1=asKat+asUnitKlasaH;/*nazwa pliku ze ciek*/
  Memo1->Lines->LoadFromFile(as1);/*adowanie pliku z deklaracj klasy*/
  //=== Wywietlenie implementacji metod klasy ===============
  AnsiString as2=asKat+asUnitKlasaCPP;/*nazwa pliku ze ciek*/
  Memo2->Lines->LoadFromFile(as2);/*adowanie pliku z implementacjami metod klasy*/
  //=== Wywietlenie pliku z komponentami klasy ===============
  AnsiString as3=asKat+asUnitMainCPP;/*nazwa pliku ze ciek*/
  Memo3->Lines->LoadFromFile(as3);/*adowanie pliku z obiektami klasy*/
  //==========================================================
}
//---------------------------------------------------------------------------
//=== Przykad. Konstrukcja throw z konstruktorem obiektu klasy wyjatku
/***double Dzielen(int d)
{
  double ret=0;
  if (d==0) throw exc(5);
  else ret=1/d;
  return ret;
}***/
//=== Ograniczenie obsugiwania wyjtku
/***double Dzielen(int d) throw()
{
  double ret=0;
  if (d==0) throw exc(5);
  else ret=1/d;
  return ret;
}***/
//=== Przykad. Funkcja w jzyku C++ z blokiem try-catch.
double Dzielen(int d)
{
  double ret=0;
  try
  { if (d==0) throw exception();
    else ret=1/d;
  }
  catch (exception& par)
  { // tekst komunikatu standardowego:
    Application->MessageBox(par.what(),"Komunikat",MB_OK);
    // tekst "swojego" komunikatu:
    Application->MessageBox
      ("Nie mona wprowadza zero", "Komunikat", MB_OK);
  }
  return ret;
}

void __fastcall TFormMain::BitBtnStartClick(TObject *Sender)
{
//=== Przykad. Konstrukcja throw z konstruktorem obiektu klasy wy-jatku
/* fragment programu: */
  try { Dzielen(0); }
  catch (exc& par)
  { // tekst komunikatu:
    char temp[128];
    sprintf(temp,"Test %d",par.aa);
    Application->MessageBox(temp, "Komunikat", MB_OK);
  }
}
//---------------------------------------------------------------------------







