#if !defined(KLIENTASYNSINK_H__)
#define KLIENTASYNSINK_H__
#include <atlbase.h>
#include <utilcls.h>
#include "SerwerAsyn_TLB.h"
// Klasa obsugujca interfejs IProcesorAsynEvents
class TProcesorAsynSink : public TEventDispatcher<TProcesorAsynSink,
  &DIID_IProcesorAsynEvents>
{
protected:
  // Dystrybutor zdarze
  HRESULT InvokeEvent(DISPID id, TVariant* params)
  { if ((id == 1) && (OnParamProcesorGotowe != NULL))
    { Variant v=params[0];
      Variant v2=VarAsType(v,varString);
      AnsiString aa=v2.operator AnsiString();
      LPSTR lp=aa.c_str();
      OnParamProcesorGotowe(lp);
    }
    return S_OK;
  }
  // Referencja do rda zdarzenia
  CComPtr<IUnknown> m_pSender;
public:
  TProcesorAsynSink(): m_pSender(NULL) { }
  virtual ~TProcesorAsynSink() { Disconnect(); }
  // Poczenie z serwerem
  void Connect(IUnknown* pSender)
  { if (pSender != m_pSender) m_pSender = pSender;
    if (NULL != m_pSender) ConnectEvents(m_pSender);
  }
  // Odczenie od serwera
  void Disconnect()
  { if (NULL != m_pSender)
    { DisconnectEvents(m_pSender);
      m_pSender = NULL;
    }
  }
};
#endif //KLIENTASYNSINK_H__

