//---------------------------------------------------------------------------

#ifndef UnitMainH
#define UnitMainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <DBGrids.hpp>
#include <Grids.hpp>
#include <ADODB.hpp>
#include <DB.hpp>
//---------------------------------------------------------------------------
class TMainForm : public TForm
{
__published:	// IDE-managed Components
  TStatusBar *StatusBar1;
  TPageControl *PageControl1;
  TTabSheet *TabSheet1;
  TLabel *Label7;
  TMemo *Memo1;
  TTabSheet *TabSheet2;
  TLabel *Label1;
  TLabel *Label2;
  TMonthCalendar *Kalendarz;
  TMemo *MemoInfo;
  TButton *ButtonZnakZodiaku;
  TButton *ButtonClear;
  TButton *ButtonZamknij;
  TButton *ButtonPrzepisz;
  TButton *ButtonOdswiez;
  TButton *ButtonZapisywanie;
  TCheckBox *CheckBoxConnect;
  TDBGrid *DBGridZodiak;
  void __fastcall ButtonZnakZodiakuClick(TObject *Sender);
  void __fastcall ButtonClearClick(TObject *Sender);
  void __fastcall ButtonZamknijClick(TObject *Sender);
  void __fastcall ButtonZapisywanieClick(TObject *Sender);
  void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
  void __fastcall CheckBoxConnectClick(TObject *Sender);
  void __fastcall ButtonPrzepiszClick(TObject *Sender);
  void __fastcall ButtonOdswiezClick(TObject *Sender);
  void __fastcall FormCreate(TObject *Sender);
private:	// User declarations
  String DataFileName;
  String BaseFileName;
  void PokazZnakInform(TDataSet* pds,TStrings* pss);
public:		// User declarations
        void __fastcall LoadData();
        void __fastcall UpdateData();
        void __fastcall SaveData();
protected:

public:		// User declarations
  __fastcall TMainForm(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TMainForm *MainForm;
//---------------------------------------------------------------------------
#endif
