//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "UnitData.h"
#include "UnitMain.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
///const AnsiString asUnitKlasaH("UnitKlasa.h");/*nazwa pliku*/
///const AnsiString asUnitKlasaCPP("UnitKlasa.cpp");/*nazwa pliku*/
const AnsiString asUnitMainCPP("UnitMain.cpp");/*nazwa pliku*/
TMainForm *MainForm;
//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
  : TForm(Owner)
{
  ShortDateFormat = ("yyyy-mm-dd");
  //----------------------------
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::FormCreate(TObject *Sender)
{
  //=== Wywietlenie deklaracji klasy ========================
  /*---nazwa katalogu, w ktrym znajduje si aplikacja:*/
  AnsiString asKat=ExtractFilePath(ParamStr(0));
  //=== Wywietlenie pliku z komponentami klasy ===============
  AnsiString as1=asKat+asUnitMainCPP;/*nazwa pliku ze ciek*/
  Memo1->Lines->LoadFromFile(as1);/*adowanie pliku z obiektami klasy*/
  //==========================================================

}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ButtonZnakZodiakuClick(TObject *Sender)
{
  if (ZodiakDataModule->SQLConnectionZodiak->Connected==false)
    ZodiakDataModule->SQLConnectionZodiak->Connected=true;
  ZodiakDataModule->SQLDataSetZodiak->Open();
  PokazZnakInform(ZodiakDataModule->SQLDataSetZodiak,MemoInfo->Lines);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ButtonClearClick(TObject *Sender)
{
  MemoInfo->Lines->Clear();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ButtonZamknijClick(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormCloseQuery(TObject *Sender, bool &CanClose)
{
  if(ZodiakDataModule->SQLDataSetZodiak->Active)
  {
    if (ZodiakDataModule->SQLConnectionZodiak->Connected)
      ZodiakDataModule->SQLConnectionZodiak->Connected=false;
  }
}
//---------------------------------------------------------------------------
void TMainForm::PokazZnakInform(TSQLDataSet* pds,TStrings* pss)
{
  int nn=pds->RecordCount;
  if (nn==0) return;
  //-------------------------------
  TDateTime TheDate(Kalendarz->Date);
  unsigned short year = 0;
  unsigned short month = 0;
  unsigned short day = 0;
  TheDate.DecodeDate(&year, &month, &day);
  //-------------------------------
  StringGrid1->ColCount=pds->FieldCount;
  StringGrid1->RowCount=1+pds->RecordCount;
  StringGrid1->Cells[0][0]=AnsiString("No");
  StringGrid1->Cells[1][0]=AnsiString("Znak");
  StringGrid1->Cells[2][0]=AnsiString("ywio");
  StringGrid1->Cells[3][0]=AnsiString("Planeta");
  StringGrid1->Cells[4][0]=AnsiString("Szczegy");
  StringGrid1->Cells[5][0]=AnsiString("Rady");
  StringGrid1->Cells[6][0]=AnsiString("Mies. pocz.");
  StringGrid1->Cells[7][0]=AnsiString("Dzie pocz.");
  StringGrid1->Cells[8][0]=AnsiString("Mies. koc.");
  StringGrid1->Cells[9][0]=AnsiString("Dzie koc.");
  //-------------------------------
  pds->First(); /* zapis pierwsza */
  for (int j=0;j<nn;j++)
  {
    int k=j+1;
    AnsiString as1=pds->FieldByName("Name")->AsString;
    AnsiString as2=pds->FieldByName("Element")->AsString;
    AnsiString as3=pds->FieldByName("Planet")->AsString;
    AnsiString as4=pds->FieldByName("Description")->AsString;
    AnsiString as5=pds->FieldByName("Advice")->AsString;
    short shStartMonth=pds->FieldByName("StartMonth")->AsInteger;
    short shStartDay=pds->FieldByName("StartDay")->AsInteger;
    short shEndMonth=pds->FieldByName("EndMonth")->AsInteger;
    short shEndDay=pds->FieldByName("EndDay")->AsInteger;
    //--------------------------------------------
    StringGrid1->Cells[0][k]=AnsiString(k);
    StringGrid1->Cells[1][k]=as1;
    StringGrid1->Cells[2][k]=as2;
    StringGrid1->Cells[3][k]=as3;
    StringGrid1->Cells[4][k]=as4;
    StringGrid1->Cells[5][k]=as5;
    StringGrid1->Cells[6][k]=AnsiString(shStartMonth);
    StringGrid1->Cells[7][k]=AnsiString(shStartDay);
    StringGrid1->Cells[8][k]=AnsiString(shEndMonth);
    StringGrid1->Cells[9][k]=AnsiString(shEndDay);
    //--------------------------------------------
    if (month==shStartMonth && day>=shStartDay ||
        month==shEndMonth && day<=shEndDay)
    {/* s sprawdzane dzie i miesic */
      pss->Add(("Informacje o znaku zodiaku:"));
      pss->Add(("  Znak = ") + as1);
      pss->Add(("  ywio = ") + as2);
      pss->Add(("  Planeta = ") + as3);
      pss->Add(("  Szczegy = ") + as4);
      pss->Add(("  Rady = ") + as5);
      pss->Add((""));
      pss->Add((""));
    }
    pds->Next(); /* zapis nastepna */
  }//j
}
//---------------------------------------------------------------------------

