//---plik UnitMain.cpp------------------------------
#include <vcl.h>
#include <typeinfo.h>
#pragma hdrstop
#include "UnitKlasa.h"
#include "UnitMain.h"
//---------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
const AnsiString asUnitKlasaH("UnitKlasa.h");/*nazwa pliku*/
const AnsiString asUnitKlasaCPP("UnitKlasa.cpp");/*nazwa pliku*/
const AnsiString asUnitMainCPP("UnitMain.cpp");/*nazwa pliku*/

TFormMain *FormMain;
//---------------------------------------------------
__fastcall TFormMain::TFormMain(TComponent* Owner)
  : TForm(Owner)
{
  pliczn1=NULL;
  pliczn2=NULL;
  pliczn3=NULL;
}
//---------------------------------------------------
void __fastcall TFormMain::BitBtnStartClick(TObject *Sender)
{
  //=== Wywietlenie deklaracji klasy ========================
  /*---nazwa katalogu, w ktrym znajduje si aplikacja:*/
  AnsiString asKat=ExtractFilePath(ParamStr(0));
  AnsiString as1=asKat+asUnitKlasaH;/*nazwa pliku ze ciek*/
  Memo1->Lines->LoadFromFile(as1);/*adowanie pliku z deklaracj klasy*/
  //=== Wywietlenie implementacji metod klasy ===============
  AnsiString as2=asKat+asUnitKlasaCPP;/*nazwa pliku ze ciek*/
  Memo2->Lines->LoadFromFile(as2);/*adowanie pliku z implementacjami metod klasy*/
  //=== Wywietlenie pliku z komponentami klasy ===============
  AnsiString as3=asKat+asUnitMainCPP;/*nazwa pliku ze ciek*/
  Memo3->Lines->LoadFromFile(as3);/*adowanie pliku z obiektami klasy*/
  //--------------------
  StaticText4->Caption=AnsiString(Licznik::maxLiczba);/*wywietlenie*/
  StaticText5->Caption=AnsiString(Licznik::krok);/*wywietlenie*/
  //==========================================================
  Zerowanie();
}
void TFormMain::Zerowanie()
{
  if (pliczn3)
  { /*niszczenie obiektu*/
    delete pliczn3; pliczn3=NULL;
    StaticText3->Caption=AnsiString(Licznik::liczbaObjekt);/*wywietlenie*/
  }
  if (pliczn2)
  { /*niszczenie obiektu*/
    delete pliczn2; pliczn2=NULL;
    StaticText3->Caption=AnsiString(Licznik::liczbaObjekt);/*wywietlenie*/
  }
  if (pliczn1)
  { /*niszczenie obiektu*/
    delete pliczn1; pliczn1=NULL;
    StaticText3->Caption=AnsiString(Licznik::liczbaObjekt);/*wywietlenie*/
  }
  CheckBox1->Checked=false;
  BitBtnKreacjaOb1->Caption=AnsiString("Kreacja");
  StaticText1->Caption=AnsiString("");/*wywietlenie stanu*/
  CheckBox2->Checked=false;
  BitBtnOb2->Caption=AnsiString("Obiekt2 := Obiekt1");
  StaticText2->Caption=AnsiString("");/*wywietlenie stanu*/
  CheckBox3->Checked=false;
  BitBtnOb3->Caption=AnsiString("Stan ob.3 := Stan ob.2");
  StaticText6->Caption=AnsiString("");/*wywietlenie stanu*/
  Licznik::liczbaObjekt=0; /* liczenie obiektw */
}
//---------------------------------------------------
void __fastcall TFormMain::BitBtnPlus1Click(TObject *Sender)
{
  if (pliczn1==NULL) return;
  ++pliczn1->stan; /* korzystanie z waciwoci klasy */
  /* korzystanie z waciwoci klasy: */
  StaticText1->Caption=AnsiString(pliczn1->stan);/*wywietlenie stanu*/
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::BitBtnPlusKrokClick(TObject *Sender)
{
  if (pliczn1==NULL) return;
  pliczn1->PlusKrok();
  /* korzystanie z waciwoci klasy: */
  StaticText1->Caption=AnsiString(pliczn1->stan);/*wywietlenie stanu*/
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::FormCloseQuery(TObject *Sender, bool &CanClose)
{
  if (pliczn1) { delete pliczn1; pliczn1=NULL; }
  if (pliczn2) { delete pliczn2; pliczn2=NULL; }
  if (pliczn3) { delete pliczn3; pliczn3=NULL; }
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::BitBtnKreacjaOb1Click(TObject *Sender)
{
cTest1 ob1 = 7;
  ob1=ob1;
//odblokowa dla eksperymentu "explicit":
// cTest2 ob2 = 7;
//  ob2=ob2;
//========================
  if (CheckBox1->Checked==false)
  {
    if (pliczn1==NULL)
    { /*nowy obiekt:*/
      pliczn1=new Licznik;/*obiekt umieszczony na stercie*/
      Licznik::liczbaObjekt++; /* liczenie obiektw */
      pliczn1->stan=7;
      StaticText3->Caption=AnsiString(Licznik::liczbaObjekt);/*wywietlenie*/
      //--------------------
      /* korzystanie z waciwoci klasy: */
      StaticText1->Caption=AnsiString(pliczn1->stan);/*wywietlenie stanu*/
      //--------------------
      CheckBox1->Checked=true;
      BitBtnKreacjaOb1->Caption=AnsiString("Niszczenie");
    }
  }
  else
  {
    if (pliczn1)
    { /*niszczenie obiektu*/
      delete pliczn1; pliczn1=NULL;
      StaticText3->Caption=AnsiString(Licznik::liczbaObjekt);/*wywietlenie*/
      StaticText1->Caption=AnsiString("");/*wywietlenie stanu*/
      //--------------------
      CheckBox1->Checked=false;
      BitBtnKreacjaOb1->Caption=AnsiString("Kreacja");
    }
  }
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::BitBtnOb2Click(TObject *Sender)
{
  if (CheckBox2->Checked==false)
  {
    if (pliczn2==NULL)
    { /*nowy obiekt:*/
      pliczn2=new Licznik(*pliczn1); /* konstruktor kopicy */
      StaticText2->Caption=AnsiString(pliczn2->stan);/*wywietlenie stanu*/
      StaticText3->Caption=AnsiString(Licznik::liczbaObjekt);/*wywietlenie*/
      //--------------------
      CheckBox2->Checked=true;
      BitBtnOb2->Caption=AnsiString("Niszczenie obiektu 2");
    }
  }
  else
  {
    if (pliczn2)
    { /*niszczenie obiektu*/
      delete pliczn2; pliczn2=NULL;
      StaticText3->Caption=AnsiString(Licznik::liczbaObjekt);/*wywietlenie*/
      StaticText2->Caption=AnsiString("");/*wywietlenie stanu*/
      //--------------------
      CheckBox2->Checked=false;
      BitBtnOb2->Caption=AnsiString("Obiekt2 := Obiekt1");
    }
  }

}
//---------------------------------------------------------------------------
void __fastcall TFormMain::BitBtnOb3Click(TObject *Sender)
{
  if (CheckBox3->Checked==false)
  {
    if (pliczn3==NULL)
    { /*nowy obiekt*/
      pliczn3=new Licznik(pliczn2->stan);/*konstruktor z argumentem*/
      Licznik::liczbaObjekt++; /* liczenie obiektw */
      StaticText3->Caption=AnsiString(Licznik::liczbaObjekt);/*wywietlenie*/
      StaticText6->Caption=AnsiString(pliczn3->stan);/*wywietlenie stanu*/
      //--------------------
      CheckBox3->Checked=true;
      BitBtnOb3->Caption=AnsiString("Niszczenie obiektu 3");
    }
  }
  else
  {
    if (pliczn3)
    { /*niszczenie obiektu*/
      delete pliczn3; pliczn3=NULL;
      StaticText3->Caption=AnsiString(Licznik::liczbaObjekt);/*wywietlenie*/
      StaticText6->Caption=AnsiString("");/*wywietlenie stanu*/
      //--------------------
      CheckBox3->Checked=false;
      BitBtnOb3->Caption=AnsiString("Stan ob.3 := Stan ob.2");
    }
  }
}
//---------------------------------------------------------------------------

void __fastcall TFormMain::FormCreate(TObject *Sender)
{
  BitBtnStartClick(this);  
}
//---------------------------------------------------------------------------

