//---plik UnitKlasa.h---------------------------
#include <vcl.h>
#ifndef UnitKlasaH
#define UnitKlasaH
//----------------------------------------------
class cA
{
  int liczba;
public:
  cA(int pocz);
  int Plus1();
  int PodajLiczba();
};
class cB : public cA
///class cB : protected cA
{
public:
  cB(int pocz);
};
class cC : public cA
//class cC : private cA
{
public:
  cC(int pocz);
};
class cE
{
  int liczba;
public:
  cE(int pocz) {liczba=pocz;};
public:
  virtual void f(void) {}; // Metoda wirtualna
};
class cD : public cE
{
public:
  cD():cE(0){};
};
class cF
{
///protected:
  int f;
public:
  cF(int k){ f=k; };
};
class cG: private cF
{ int g;
public:
  cG(int i): g(2*i),cF(g){};
};
extern char wynik[];
extern int index;
class cH
{ public:
  virtual ~cH() // destruktor wirtualny
  { wynik[index++]='H'; }
};
class cJ : public cH
{ public:
  ~cJ() // ten destruktor te jest wirtualny
  { wynik[index++]='J'; }
};
class cK : public cJ
{ public:
  ~cK() // ten destruktor te jest wirtualny
  { wynik[index++]='K'; }
};
//=== Stos na bazie tablicy liczb cakowitych ===
class StosT //opis klasy
{
  int array[1000]; int index;
public:
  StosT();
  bool CzyStosPusty();
  void push(int elem);
  int pop();
  void Pokaz(TListBox* plb);
};
//=== Stos na bazie struktury listowej =====
struct ElListy //struktura elementu listy
{
  int elem;
  ElListy *pNast;
};
class StosL //deklaracja klasy
{
  ElListy *pList;
public:
  StosL();
  ~StosL(); //destruktor
  bool CzyStosPusty();
  void push(int elem);
  int pop();
  void Pokaz(TListBox* plb);
};
//=== Przecienie (ang. overloading) metody ======
class Licznik //pocztek opisania klasy
{ int liczba; //opis pola klasy
public:
  Licznik(); //opis konstruktora klasy
  void Set(int value); //metoda przeciona
  void Set(char *pText); //metoda przeciajca
  int Podaj();
};

#endif
