//---plik UnitMain.cpp------------------------------
#include <vcl.h>
#include <typeinfo.h>
#pragma hdrstop
#include "UnitKlasa.h"
#include "UnitMain.h"
//---------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
const AnsiString asUnitKlasaH("UnitKlasa.h");/*nazwa pliku*/
const AnsiString asUnitKlasaCPP("UnitKlasa.cpp");/*nazwa pliku*/
const AnsiString asUnitMainCPP("UnitMain.cpp");/*nazwa pliku*/
char wynik[]="oooooooooo";
int index=0;

TFormMain *FormMain;
//---------------------------------------------------
__fastcall TFormMain::TFormMain(TComponent* Owner)
  : TForm(Owner)
{
  pobA=NULL;
  pobB=NULL;
  pobC=NULL;
  pStosT=NULL;
  pStosL=NULL;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::FormCloseQuery(TObject *Sender, bool &CanClose)
{
  if (pobA) { delete pobA; pobA=NULL; }
  if (pobB) { delete pobB; pobB=NULL; }
  if (pobC) { delete pobC; pobC=NULL; }
  if (pStosT) { delete pStosT; pStosT=NULL; }
  if (pStosL) { delete pStosL; pStosL=NULL; }
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::BitBtnObAClick(TObject *Sender)
{
  if (pobA==NULL)
  { /*nowy obiekt:*/
    pobA=new cA(5);/*obiekt umieszczony na stercie*/
    int stan=pobA->PodajLiczba();
    StaticText1->Caption=AnsiString(stan);/*wywietlenie stanu*/
  }
}

//---------------------------------------------------------------------------
void __fastcall TFormMain::BitBtnObBClick(TObject *Sender)
{
  if (pobB==NULL)
  { /*nowy obiekt:*/
    pobB=new cB(10);
    int stan=pobB->PodajLiczba();
    StaticText2->Caption=AnsiString(stan);/*wywietlenie stanu*/
  }
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::BitBtnObAPlus1Click(TObject *Sender)
{
  if (pobA==NULL) return;
  int stan=pobA->Plus1();
  StaticText1->Caption=AnsiString(stan);/*wywietlenie stanu*/
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::BitBtnObBPlus1Click(TObject *Sender)
{
  if (pobB)
  {
    pobB->Plus1();
    int stan=pobB->PodajLiczba();
    StaticText2->Caption=AnsiString(stan);/*wywietlenie stanu*/
  }
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::FormCreate(TObject *Sender)
{
  //=== Wywietlenie deklaracji klasy ========================
  /*---nazwa katalogu, w ktrym znajduje si aplikacja:*/
  AnsiString asKat=ExtractFilePath(ParamStr(0));
  AnsiString as1=asKat+asUnitKlasaH;/*nazwa pliku ze ciek*/
  Memo1->Lines->LoadFromFile(as1);/*adowanie pliku z deklaracj klasy*/
  //=== Wywietlenie implementacji metod klasy ===============
  AnsiString as2=asKat+asUnitKlasaCPP;/*nazwa pliku ze ciek*/
  Memo2->Lines->LoadFromFile(as2);/*adowanie pliku z implementacjami metod klasy*/
  //=== Wywietlenie pliku z komponentami klasy ===============
  AnsiString as3=asKat+asUnitMainCPP;/*nazwa pliku ze ciek*/
  Memo3->Lines->LoadFromFile(as3);/*adowanie pliku z obiektami klasy*/
  //==========================================================
}
//---------------------------------------------------------------------------

void __fastcall TFormMain::BitBtnStartClick(TObject *Sender)
{
//=== Dziedziczenie uprawnie dostpu =========
  cA obA(5);
  cB obB(10);
  cC obC(15);
  int nA=obA.Plus1();
  nA=nA;
  int nB=obB.Plus1();//?? kompilator informuje o bdzie
  nB=nB;
  int nC=obC.Plus1();//?? kompilator informuje o bdzie
  nC=nC;
//=== Rzutowanie typw =================================
  cD d;
  cD* pd=NULL;
  cE* pe=&d; /* automatyczna konwersja typu wskanika w kierunku "klasa pochodna - klasa bazowa" */
  pd=dynamic_cast<cD*>(pe); /* konwersja typu wskanika w kierunku "klasa bazowa - klasa pochodna" */
  pd=pd;
//=== Wywoanie konstruktorw z list inicjacyjn =======
  cG obG(10);
//=== Destruktory wirtualne =========
  cH *p[3]; //wskaniki na obiekty klasy cH
  p[0] = new cJ;//alokacja obiektu klasy cJ
  p[1] = new cK;//alokacja obiektu klasy cK
  p[2] = new cH;//alokacja obiektu klasy cH
  delete p[0]; //acuch z destruktorw cJ i cH
  delete p[1]; //acuch z destruktorw cK, cJ i cH
  delete p[2]; //acuch z destruktora cH
  p[0]=p[0];// tutaj ustawi pozycj zatrzymania programu
        // i sprawdzi, e wynik[]="JHKJHHoooo";

}
//---------------------------------------------------------------------------

void __fastcall TFormMain::BitBtnDodajTClick(TObject *Sender)
{
  if (pStosT==NULL) pStosT=new StosT;
  int nn=UpDownStosT->Position;
  pStosT->push(nn);
  pStosT->Pokaz(ListBoxStosT);
}
//---------------------------------------------------------------------------

void __fastcall TFormMain::BitBtnDodajLClick(TObject *Sender)
{
  if (pStosL==NULL) pStosL=new StosL;
  int nn=UpDownStosL->Position;
  pStosL->push(nn);
  pStosL->Pokaz(ListBoxStosL);

}
//---------------------------------------------------------------------------

void __fastcall TFormMain::BitBtnZdejmijTClick(TObject *Sender)
{
  if (pStosT==NULL) return;
  if (pStosT->CzyStosPusty()==false)
  {
    int nn=pStosT->pop();
    EditStosT->Text=AnsiString(nn);
    pStosT->Pokaz(ListBoxStosT);
  }

}
//---------------------------------------------------------------------------

void __fastcall TFormMain::BitBtnZdejmijLClick(TObject *Sender)
{
  if (pStosL==NULL) return;
  if (pStosL->CzyStosPusty()==false)
  {
    int nn=pStosL->pop();
    EditStosL->Text=AnsiString(nn);
    pStosL->Pokaz(ListBoxStosL);
  }

}
//---------------------------------------------------------------------------

void __fastcall TFormMain::BitBtnSet1Click(TObject *Sender)
{
  AnsiString as=EditZapis->Text;
  int nn=as.ToInt();
  Licznik liczn;
  liczn.Set(nn); //metoda Set_1
  nn=liczn.Podaj();
  as=AnsiString(nn);
  EditOdczyt->Text=as;
}
//---------------------------------------------------------------------------

void __fastcall TFormMain::BitBtnSet2Click(TObject *Sender)
{
  AnsiString as=EditZapis->Text;
  char* pch=as.c_str();
  Licznik liczn;
  liczn.Set(pch); //metoda Set_2
  int nn=liczn.Podaj();
  as=AnsiString(nn);
  EditOdczyt->Text=as;

}
//---------------------------------------------------------------------------

void __fastcall TFormMain::BitBtnObCClick(TObject *Sender)
{
  if (pobC==NULL)
  { /*nowy obiekt:*/
    pobC=new cC(20);
    int stan=pobC->PodajLiczba();
    StaticText3->Caption=AnsiString(stan);/*wywietlenie stanu*/
  }
}
//---------------------------------------------------------------------------

void __fastcall TFormMain::BitBtnObCPlus1Click(TObject *Sender)
{
  if (pobC)
  {
    pobC->Plus1();
    int stan=pobC->PodajLiczba();
    StaticText3->Caption=AnsiString(stan);/*wywietlenie stanu*/
  }
}
//---------------------------------------------------------------------------

