//---plik UnitKlasa.h---------------------------
#include <vcl.h>
#ifndef UnitKlasaH
#define UnitKlasaH
//----------------------------------------------
//=== Przykad 6.1. Klasa dynInt z przecionymi operatorami ====
class dynInt
{
protected:
  int *m_pData;   // wskanik do tablicy
  int m_nSize;     // rozmiar aktualny
  int m_nMaxSize;  // rozmiar zaalokowany
  int m_nGrowBy;   // krok przy zwikszeniu
public:
  dynInt();
  dynInt(dynInt& ob); //konstruktor kopiujcy
  dynInt(int size,int growBy);
  ~dynInt();
  int fGetSize() const;
  void fSetSize(int newsize, int nGrowBy = -1);
  void fSetAtGrow(int nIndex, int newElement);
  dynInt& operator=(const dynInt &C);
  int& operator[](int nIndex);
  const int& operator[](const int nIndex) const;
  int operator()(int nBegIndex,int nNumber);
};
//=== Przykad. czenie alokacji z inicjalizacj ====
class cA
{
  char * buffer;
public:
  cA();
  ~cA();
  void* operator new(size_t size);
  void operator delete(void* ptr);
  bool flaga;
};
//=== Przykad. Przekazywanie argumentw operatowi new ===
class cB
{ char* buffer;
public:
  ~cB();
  void* operator new(size_t size,int volumn,int symbol);
};

#endif
