//---plik UnitKlasa.h---------------------------
#include <vcl.h>
#ifndef UnitKlasaH
#define UnitKlasaH
//----------------------------------------------
//=== Przykad. Deklaracja i implementacja w jzyku C++ interfejsu ITest =====
__interface __declspec(uuid("C527B88F-3F8E-1134-80e0-01A04F57B270")) ITest
{
public:
  virtual char* GetBuff() = 0;
};
class ImplITest: public ITest
{
  char buff[1000];
public:
  ImplITest()
  {
    for (int k=0;k<10;k++)
      for (int j=0;j<10;j++)
        buff[k*10+j]='a'+k+j;
    buff[100]='\0';
  }
  char* GetBuff() { return buff; };
};
//=== Przykad. Dziedziczenie interfejsw w jzyku C++ ====
__interface IRysowanie
{ public: virtual void Rysowanie(TPaintBox* ppb) = 0 ;
};
__interface IProstokat: public IRysowanie
{ public: virtual void UstawProstokat(int ix,int iy,int idx,int idy,int itlo) = 0 ;
};
__interface ITekst: public IRysowanie
{ public: virtual void UstawTekst(int ix,int iy,AnsiString itxt,int icolor) = 0 ;
};
__interface IOkno: public IProstokat,public ITekst
{
};
class ImplIOkno: public IOkno
{
  int x,y,dx,dy,xt,yt;
  int tlo, color;
  AnsiString txt;
public:
  ImplIOkno()
  { x=0; y=0; xt=2; yt=2; dx=100; dy=20;
    tlo=0x00FFFFFF; color=0; txt=AnsiString("okno");
  }
  ImplIOkno(int ix,int iy,int idx,int idy,int ixt,int iyt,
    AnsiString itxt,int itlo,int icolor)
  { x=ix; y=iy; dx=idx; dy=idy; xt=ixt; yt=iyt;
    txt=itxt; tlo=itlo; color=icolor;
  }
  void UstawTekst(int ixt,int iyt,AnsiString itxt,int icolor)
  { xt=ixt; yt=iyt; txt=itxt; color=icolor;
  }
  void UstawProstokat(int ix,int iy,int idx,int idy,int itlo)
  { x=ix; y=iy; dx=idx; dy=idy; tlo=itlo;
  }
  void Rysowanie(TPaintBox* ppb);
};

#endif
